var j = Object.defineProperty;
var N = (e) => {
  throw TypeError(e);
};
var G = (e, t, r) => t in e ? j(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r;
var c = (e, t, r) => G(e, typeof t != "symbol" ? t + "" : t, r), L = (e, t, r) => t.has(e) || N("Cannot " + r);
var T = (e, t, r) => (L(e, t, "read from private field"), r ? r.call(e) : t.get(e)), R = (e, t, r) => t.has(e) ? N("Cannot add the same private member more than once") : t instanceof WeakSet ? t.add(e) : t.set(e, r), D = (e, t, r, s) => (L(e, t, "write to private field"), s ? s.call(e, r) : t.set(e, r), r);
var o = /* @__PURE__ */ ((e) => (e[e.CREATE_PROMISE_FAILED = 1] = "CREATE_PROMISE_FAILED", e[e.TIMEOUT = 2] = "TIMEOUT", e[e.MAX_RETRY_FAILED = 3] = "MAX_RETRY_FAILED", e[e.ABORT = 4] = "ABORT", e))(o || {}), a = /* @__PURE__ */ ((e) => (e[e.PENDING = 0] = "PENDING", e[e.FULFILLED = 1] = "FULFILLED", e[e.REJECTED = 2] = "REJECTED", e))(a || {});
const x = {
  [o.CREATE_PROMISE_FAILED]: "创建Promise失败",
  [o.TIMEOUT]: "超时",
  [o.MAX_RETRY_FAILED]: "最大重试次数失败",
  [o.ABORT]: "中止"
}, g = (e) => {
  try {
    return e();
  } catch (t) {
    return new Promise((r, s) => {
      s(
        new m(
          o.CREATE_PROMISE_FAILED,
          (t == null ? void 0 : t.message) || void 0
        )
      );
    });
  }
};
class m extends Error {
  constructor(t, r = x[t]) {
    super(r), this.code = t;
  }
}
let U = 0;
const W = (e, t) => (r, s) => {
  t.resolveWrap = (i) => {
    if (t.state !== a.PENDING) {
      console.log(`当前状态已经变为${t.state}, 忽略resolve`);
      return;
    }
    t.endTime = Date.now(), console.log(
      `${t.index} 调用成功${t.num++}次`,
      i,
      `耗时${t.endTime - t.startTime}ms`
    ), t.state = a.FULFILLED, t.clearTimeoutTimer(), r(i);
  }, t.rejectWrap = (i) => {
    if (t.state !== a.PENDING) {
      console.log(`当前状态已经变为${t.state}, 忽略reject`);
      return;
    }
    t.endTime = Date.now(), console.log(
      `${t.index} 调用失败${t.num++}次`,
      i,
      `耗时${t.endTime - t.startTime}ms`
    ), t.state = a.REJECTED, t.clearTimeoutTimer(), s(i);
  }, e(t.resolveWrap, t.rejectWrap);
}, C = (e) => {
  const t = {
    timeoutTimer: void 0,
    clearTimeoutTimer() {
      this.timeoutTimer && (clearTimeout(this.timeoutTimer), this.timeoutTimer = void 0);
    },
    startTime: Date.now(),
    state: a.PENDING,
    num: 0,
    index: U++
  }, r = W(e, t);
  return t.promise = new Promise(r), t.promise.catch((s) => {
    var i;
    return t.state === a.PENDING && (console.log("promise 内部出现pending状态错误", s), (i = t.rejectWrap) == null || i.call(t, s)), s;
  }), {
    baseInfo: t
  };
}, P = (e) => {
  let t;
  return {
    applyPromise: () => (t || (t = g(() => e()), t.catch(() => {
      t = void 0, console.log("Promise sharing: promise出错，已重置");
    })), t)
  };
};
class B extends m {
  constructor(t, r = `执行${t.length}次(重试${t.length - 1}次)，最终仍失败`) {
    super(o.MAX_RETRY_FAILED, r), this.errorList = t;
  }
}
const O = (e, {
  maxRetry: t = 0,
  canRetry: r = (i) => i < Math.max(t, 0),
  delay: s = 0
}) => {
  let i = 0;
  const A = [], $ = typeof s == "function" ? s : () => s;
  return new Promise((d, v) => {
    const h = () => {
      g(() => e(i)).then(d).catch((I) => {
        if (A.push(I), r(i)) {
          i++;
          const w = $(i);
          w > 0 ? setTimeout(h, w) : h();
        } else
          v(new B(A));
      });
    };
    h();
  });
};
class y extends m {
  constructor(t = x[o.ABORT]) {
    super(o.ABORT, t);
  }
}
var E;
const u = class u {
  constructor(t) {
    /** promise原始reject函数 */
    R(this, E);
    D(this, E, t);
  }
  /** 取消 promise */
  cancel(t) {
    T(this, E).call(this, t);
  }
};
E = new WeakMap(), /** 是否取消错误 */
c(u, "isCancelError", (t) => t instanceof y), /** 创建 promise 取消令牌 */
c(u, "source", (t) => new u(t));
let p = u;
function _(e, t) {
  return g(e).catch(() => typeof t == "function" ? t() : t);
}
const Y = (e, {
  maxRetry: t,
  delay: r
}) => O(e, {
  canRetry: (s) => s < t,
  delay: r
});
var M, l;
M = Symbol.toStringTag;
const n = class n {
  constructor(t) {
    c(this, M, `object ${n.name}`);
    /** 原始promise上下文 */
    R(this, l);
    /** 超时设置 */
    c(this, "timeout", (t) => {
      const { baseInfo: r } = T(this, l);
      if (r.state !== a.PENDING)
        return console.warn("超时设置失败，promise状态不为pending"), this;
      r.clearTimeoutTimer();
      const s = Math.max(0, r.startTime + t - Date.now());
      return console.log(`超时设置${t}ms, 剩余${s}ms`), r.timeoutTimer = setTimeout(() => {
        console.log("走到超时时刻"), r.rejectWrap(new m(o.TIMEOUT));
      }, s), this;
    });
    /** 中止promise */
    c(this, "abort", (t) => {
      const { baseInfo: r } = T(this, l);
      return r.state !== a.PENDING ? (console.warn("取消失败，promise状态不为pending"), this) : (p.source((i) => {
        r.rejectWrap(new y(i));
      }).cancel(t), this);
    });
    D(this, l, C(t));
  }
  // 修正 then 方法
  then(t, r) {
    return new n((s, i) => {
      T(this, l).baseInfo.promise.then(t, r).then(s, i);
    });
  }
  // 修正 catch 方法
  catch(t) {
    return this.then(void 0, t);
  }
  // 修正 finally 方法
  finally(t) {
    return new n((r, s) => {
      T(this, l).baseInfo.promise.finally(t).then(r, s);
    });
  }
};
l = new WeakMap(), /** promise共享 */
c(n, "useSharing", P), /** promise重试 */
c(n, "retry", O), /** promise轮询 */
c(n, "polling", Y), /** promise无错 */
c(n, "noReject", _), /** 是否是取消/中止错误 */
c(n, "isCancelError", p.isCancelError), /** 是否是超时错误 */
c(n, "isTimeoutError", (t) => t instanceof m && t.code === o.TIMEOUT);
let F = n;
export {
  F as XPromise,
  m as XPromiseError,
  o as XPromiseErrorCodeEnum
};
